# coding: utf-8

"""
    VMware Aria Automation Assembler Blueprint API

    A multi-cloud Blueprint API for VMware Aria Automation Services  This page describes the RESTful APIs for Blueprint. The APIs facilitate CRUD operations on the various resources and entities used throughout Blueprint (Blueprints, Blueprint Terraform Integrations , PropertyGroups , etc.) and allow operations on them (creating a Blueprint, creating a Property group, etc.).  The APIs that list collections of resources  also support OData like implementation. Below query params can be used across Blueprint entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/blueprint/api/blueprints?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/blueprint/api/blueprints?$top=10&$skip=2```   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PagePropertyGroupContent(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'type': 'str',
        'id': 'str',
        'created_at': 'datetime',
        'created_by': 'str',
        'updated_at': 'datetime',
        'updated_by': 'str',
        'org_id': 'str',
        'project_id': 'str',
        'project_name': 'str',
        'name': 'str',
        'display_name': 'str',
        'description': 'str',
        'properties': 'dict(str, PropertiesapipropertygroupspropertyGroupIdProperties)'
    }

    attribute_map = {
        'type': 'type',
        'id': 'id',
        'created_at': 'createdAt',
        'created_by': 'createdBy',
        'updated_at': 'updatedAt',
        'updated_by': 'updatedBy',
        'org_id': 'orgId',
        'project_id': 'projectId',
        'project_name': 'projectName',
        'name': 'name',
        'display_name': 'displayName',
        'description': 'description',
        'properties': 'properties'
    }

    def __init__(self, type=None, id=None, created_at=None, created_by=None, updated_at=None, updated_by=None, org_id=None, project_id=None, project_name=None, name=None, display_name=None, description=None, properties=None):  # noqa: E501
        """PagePropertyGroupContent - a model defined in Swagger"""  # noqa: E501
        self._type = None
        self._id = None
        self._created_at = None
        self._created_by = None
        self._updated_at = None
        self._updated_by = None
        self._org_id = None
        self._project_id = None
        self._project_name = None
        self._name = None
        self._display_name = None
        self._description = None
        self._properties = None
        self.discriminator = None
        if type is not None:
            self.type = type
        if id is not None:
            self.id = id
        if created_at is not None:
            self.created_at = created_at
        if created_by is not None:
            self.created_by = created_by
        if updated_at is not None:
            self.updated_at = updated_at
        if updated_by is not None:
            self.updated_by = updated_by
        if org_id is not None:
            self.org_id = org_id
        if project_id is not None:
            self.project_id = project_id
        if project_name is not None:
            self.project_name = project_name
        if name is not None:
            self.name = name
        if display_name is not None:
            self.display_name = display_name
        if description is not None:
            self.description = description
        if properties is not None:
            self.properties = properties

    @property
    def type(self):
        """Gets the type of this PagePropertyGroupContent.  # noqa: E501

        Property group type  # noqa: E501

        :return: The type of this PagePropertyGroupContent.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this PagePropertyGroupContent.

        Property group type  # noqa: E501

        :param type: The type of this PagePropertyGroupContent.  # noqa: E501
        :type: str
        """
        allowed_values = ["INPUT", "CONSTANT"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def id(self):
        """Gets the id of this PagePropertyGroupContent.  # noqa: E501

        Object ID  # noqa: E501

        :return: The id of this PagePropertyGroupContent.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PagePropertyGroupContent.

        Object ID  # noqa: E501

        :param id: The id of this PagePropertyGroupContent.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def created_at(self):
        """Gets the created_at of this PagePropertyGroupContent.  # noqa: E501

        Created time  # noqa: E501

        :return: The created_at of this PagePropertyGroupContent.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this PagePropertyGroupContent.

        Created time  # noqa: E501

        :param created_at: The created_at of this PagePropertyGroupContent.  # noqa: E501
        :type: datetime
        """

        self._created_at = created_at

    @property
    def created_by(self):
        """Gets the created_by of this PagePropertyGroupContent.  # noqa: E501

        Created by  # noqa: E501

        :return: The created_by of this PagePropertyGroupContent.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this PagePropertyGroupContent.

        Created by  # noqa: E501

        :param created_by: The created_by of this PagePropertyGroupContent.  # noqa: E501
        :type: str
        """

        self._created_by = created_by

    @property
    def updated_at(self):
        """Gets the updated_at of this PagePropertyGroupContent.  # noqa: E501

        Updated time  # noqa: E501

        :return: The updated_at of this PagePropertyGroupContent.  # noqa: E501
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this PagePropertyGroupContent.

        Updated time  # noqa: E501

        :param updated_at: The updated_at of this PagePropertyGroupContent.  # noqa: E501
        :type: datetime
        """

        self._updated_at = updated_at

    @property
    def updated_by(self):
        """Gets the updated_by of this PagePropertyGroupContent.  # noqa: E501

        Updated by  # noqa: E501

        :return: The updated_by of this PagePropertyGroupContent.  # noqa: E501
        :rtype: str
        """
        return self._updated_by

    @updated_by.setter
    def updated_by(self, updated_by):
        """Sets the updated_by of this PagePropertyGroupContent.

        Updated by  # noqa: E501

        :param updated_by: The updated_by of this PagePropertyGroupContent.  # noqa: E501
        :type: str
        """

        self._updated_by = updated_by

    @property
    def org_id(self):
        """Gets the org_id of this PagePropertyGroupContent.  # noqa: E501

        Org ID  # noqa: E501

        :return: The org_id of this PagePropertyGroupContent.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this PagePropertyGroupContent.

        Org ID  # noqa: E501

        :param org_id: The org_id of this PagePropertyGroupContent.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    @property
    def project_id(self):
        """Gets the project_id of this PagePropertyGroupContent.  # noqa: E501

        Project ID  # noqa: E501

        :return: The project_id of this PagePropertyGroupContent.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this PagePropertyGroupContent.

        Project ID  # noqa: E501

        :param project_id: The project_id of this PagePropertyGroupContent.  # noqa: E501
        :type: str
        """

        self._project_id = project_id

    @property
    def project_name(self):
        """Gets the project_name of this PagePropertyGroupContent.  # noqa: E501

        Project Name  # noqa: E501

        :return: The project_name of this PagePropertyGroupContent.  # noqa: E501
        :rtype: str
        """
        return self._project_name

    @project_name.setter
    def project_name(self, project_name):
        """Sets the project_name of this PagePropertyGroupContent.

        Project Name  # noqa: E501

        :param project_name: The project_name of this PagePropertyGroupContent.  # noqa: E501
        :type: str
        """

        self._project_name = project_name

    @property
    def name(self):
        """Gets the name of this PagePropertyGroupContent.  # noqa: E501

        Property group name  # noqa: E501

        :return: The name of this PagePropertyGroupContent.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PagePropertyGroupContent.

        Property group name  # noqa: E501

        :param name: The name of this PagePropertyGroupContent.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def display_name(self):
        """Gets the display_name of this PagePropertyGroupContent.  # noqa: E501

        Property group display name  # noqa: E501

        :return: The display_name of this PagePropertyGroupContent.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this PagePropertyGroupContent.

        Property group display name  # noqa: E501

        :param display_name: The display_name of this PagePropertyGroupContent.  # noqa: E501
        :type: str
        """

        self._display_name = display_name

    @property
    def description(self):
        """Gets the description of this PagePropertyGroupContent.  # noqa: E501

        Property group description  # noqa: E501

        :return: The description of this PagePropertyGroupContent.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this PagePropertyGroupContent.

        Property group description  # noqa: E501

        :param description: The description of this PagePropertyGroupContent.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def properties(self):
        """Gets the properties of this PagePropertyGroupContent.  # noqa: E501

        Properties  # noqa: E501

        :return: The properties of this PagePropertyGroupContent.  # noqa: E501
        :rtype: dict(str, PropertiesapipropertygroupspropertyGroupIdProperties)
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this PagePropertyGroupContent.

        Properties  # noqa: E501

        :param properties: The properties of this PagePropertyGroupContent.  # noqa: E501
        :type: dict(str, PropertiesapipropertygroupspropertyGroupIdProperties)
        """

        self._properties = properties

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PagePropertyGroupContent, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PagePropertyGroupContent):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
